package com.brulijam.minecraftapi.service;

import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import org.telegram.telegrambots.meta.api.objects.User;

import java.util.*;

@Component
@RequiredArgsConstructor
@Getter
public class TelegramService {

    private final List<User> telegramUsers = new ArrayList<>();
    // Maps userId to token
    private final Map<Long, String> tokens = new HashMap<>();

    public void addUserToList(User user) {
        telegramUsers.add(user);

        String randomUUID = UUID.randomUUID().toString().replaceAll("_", "");
        tokens.put(user.getId(), randomUUID);
    }

    public String getTokenByUserId(Long userId) {
        return tokens.get(userId);
    }

    public User getUserByUserId(long userId) {
        return telegramUsers.stream()
                .filter(user -> user.getId() == userId)
                .findFirst()
                .orElse(null);
    }

    public User getUserByUsername(String username) {
        return telegramUsers.stream()
                .filter(User -> User.getUserName().equals(username))
                .findFirst()
                .orElse(null);
    }

    public String getTokenByUserId(long userId) {
        return tokens.get(userId);
    }
}
